"use strict";
(function() {
    tinymce.create("tinymce.plugins.cspg_extension", {
        init : function(ed, url) { 
            ed.addButton("blue", {
                title : "COVID-19 Spread Prediction Table",
                cmd : "blue_command",
                icon: false,
                text: "COVID Table"
            });

            ed.addCommand("blue_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-spread-prediction-table starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("hnewinf", {
                title : "COVID-19 Historical Simulation Charts",
                cmd : "hnewinf_command",
                icon: false,
                text: "COVID Historical Simulation Charts"
            });

            ed.addCommand("hnewinf_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-historical-pandemic-prediction target_location=\"ITA\" chart_type=\"newinfected\" unkillable_elite_in_bunkers=\"50000\" infection_rate=\"1.3\" mortality_rate=\"2\" mortality_complicator=\"2\" burnout_rate=\"3.5\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("lila", {
                title : "COVID-19 Disease Symptoms",
                cmd : "lila_command",
                icon: false,
                text: "COVID Symptoms"
            });

            ed.addCommand("lila_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-disease-symptoms-types starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("weis", {
                title : "COVID-19 Hospitalization Chart",
                cmd : "weis_command",
                icon: false,
                text: "COVID Hospitalization"
            });

            ed.addCommand("weis_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-new-infected-hospitalization-chart starting_population=\"7727439400\" hospitalization_rate=\"20\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            }); 
            ed.addButton("color", {
                title : "COVID-19 Dashboards",
                cmd : "color_command",
                icon: false,
                text: "COVID Dashboards"
            });

            ed.addCommand("color_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-region-dashboard height_px=\"800px\" region=\"italy\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("roz", {
                title : "COVID-19 Deaths per Age Group",
                cmd : "roz_command",
                icon: false,
                text: "COVID Deaths per Age Group"
            });

            ed.addCommand("roz_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-age-group-death-rate starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("teal", {
                title : "COVID-19 Disease Severity Chart",
                cmd : "teal_command",
                icon: false,
                text: "COVID Severity"
            });

            ed.addCommand("teal_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-disease-severity-chart starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("opal", {
                title : "COVID-19 Workforce Disruption Chart",
                cmd : "opal_command",
                icon: false,
                text: "COVID Workforce"
            });

            ed.addCommand("opal_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-total-workforce-chart starting_population=\"7727439400\" workforce_percentage=\"60\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            ed.addButton("cyan", {
                title : "COVID-19 Spread Prediction Summary",
                cmd : "cyan_command",
                icon: false,
                text: "COVID Summary"
            });

            ed.addCommand("cyan_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-spread-summary-table starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" include_init_data=\"true\" include_final_data=\"true\" init_data_header_texts=\"Starting Population,Immune Population,Start Date,Initial Infections,Infection Rate,Incubation Days,Mortality Rate,Mortality Complicator,Burnout Rate,Iteration Count\" final_data_header_texts=\"Population At Risk,Total Infected,Total Recovered,Total Deaths,Total Uninfected,Population Alive\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("red", {
                title : "COVID-19 New Infected and Death Chart",
                cmd : "red_command",
                icon: false,
                text: "COVID nI-D Chart"
            });

            ed.addCommand("red_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-new-infected-death-chart starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("green", {
                title : "COVID-19 Total Infected and Death Chart",
                cmd : "green_command",
                icon: false,
                text: "COVID tI-D Chart"
            });

            ed.addCommand("green_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-total-infected-death-chart starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("white", {
                title : "COVID-19 Population Decline Chart",
                cmd : "white_command",
                icon: false,
                text: "COVID Pop Chart"
            });

            ed.addCommand("white_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-population-decline-chart starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("gray", {
                title : "COVID-19 Summary Chart",
                cmd : "gray_command",
                icon: false,
                text: "COVID Summary Chart"
            });

            ed.addCommand("gray_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-summary-chart starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("black", {
                title : "COVID-19 Total Deaths Chart",
                cmd : "black_command",
                icon: false,
                text: "COVID Death Chart"
            });

            ed.addCommand("black_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-total-deaths-chart starting_population=\"7727439400\" unkillable_elite_in_bunkers=\"50000\" start_date=\"01-01-2020\" initial_infections=\"2\" infection_rate=\"3\" incubation_days=\"10\" mortality_rate=\"3\" mortality_complicator=\"10\" burnout_rate=\"4\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("yellow", {
                title : "COVID-19 Johns Hopkins CSSE Dashboard Embed",
                cmd : "yellow_command",
                icon: false,
                text: "COVID JH Embed"
            });

            ed.addCommand("yellow_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-jh-dashboard height_px=\"800px\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("orange", {
                title : "COVID-19 WHO Dashboard Embed",
                cmd : "orange_command",
                icon: false,
                text: "COVID WHO Embed"
            });

            ed.addCommand("orange_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-who-dashboard height_px=\"800px\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("pink", {
                title : "COVID-19 User Form",
                cmd : "pink_command",
                icon: false,
                text: "COVID Form"
            });

            ed.addCommand("pink_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-user-input show_table=\"true\" show_new_infected_death_graph=\"true\" show_population_decline_graph=\"true\" show_total_deaths_graph=\"true\" show_total_deaths_infected_graph=\"true\" show_summary=\"true\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("rot", {
                title : "COVID-19 Historical Prediction Chart",
                cmd : "rot_command",
                icon: false,
                text: "COVID Historical Prediction Chart"
            });

            ed.addCommand("rot_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-historical-data-prediction target_location=\"ITA\" unkillable_elite_in_bunkers=\"50000\" infection_rate=\"1.3\" mortality_rate=\"2\" mortality_complicator=\"2\" burnout_rate=\"3.5\" iteration_count=\"50\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
            
            ed.addButton("country", {
                title : "COVID-19 Historical Prediction Chart",
                cmd : "country_command",
                icon: false,
                text: "COVID Country Query"
            });

            ed.addCommand("country_command", function() {
                var selected_text = ed.selection.getContent();
                var return_text = "[coronavirus-country-query country=\"\"]" + selected_text;
                ed.execCommand("mceInsertContent", 0, return_text);
            });
        },
        createControl : function(n, cm) {
            return null;
        },
        getInfo : function() {
            return {
                longname : "Extra Buttons",
                author : "CodeRevolution",
                version : "1.0"
            };
        }
    });
    tinymce.PluginManager.add("cspg_extension", tinymce.plugins.cspg_extension);
})();