"use strict";
var { registerBlockType } = wp.blocks;
var gcel = wp.element.createElement;

registerBlockType( 'coronavirus-spread-prediction-graphs/cspg-country', {
    title: 'COVID-19 Country Query',
    icon: 'editor-paste-word',
    category: 'embed',
    attributes: {
        country : {
            default: '',
            type:   'string',
        },
    },
    keywords: ['table', 'coronavirus', 'covid'],
    edit: (function( props ) {
        var country = props.attributes.country;
        function updateMessage( event ) {
            props.setAttributes( { country: event.target.value} );
		}
		return gcel(
			'div', 
			{ className: 'coderevolution_gutenberg_div' },
            gcel(
				'h4',
				{ className: 'coderevolution_gutenberg_title' },
                'COVID-19 Country Query',
                gcel(
                    'div', 
                    {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                    ,
                    gcel(
                        'div', 
                        {className:'bws_hidden_help_text'},
                        'This block is used to display a country query box.'
                    )
                )
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Country: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Input the name of the country to query. If you leave this field blank, the plugin will allow website visitors to enter their own values for country queries. Default is "" (empty).'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'800px', value: country, onChange: updateMessage, className: 'coderevolution_gutenberg_input' }
			)
		);
    }),
    save: (function( props ) {
       return null;
    }),
} );