"use strict";
var { registerBlockType } = wp.blocks;
var gcel = wp.element.createElement;

registerBlockType( 'coronavirus-spread-prediction-graphs/cspg-jh', {
    title: 'COVID-19 Johns Hopkins Embed',
    icon: 'editor-paste-text',
    category: 'embed',
    attributes: {
        height_px : {
            default: '',
            type:   'string',
        },
    },
    keywords: ['table', 'coronavirus', 'covid'],
    edit: (function( props ) {
        var height_px = props.attributes.height_px;
        function updateMessage( event ) {
            props.setAttributes( { height_px: event.target.value} );
		}
		return gcel(
			'div', 
			{ className: 'coderevolution_gutenberg_div' },
            gcel(
				'h4',
				{ className: 'coderevolution_gutenberg_title' },
                'Johns Hopkins Dashboard Iframe Embed',
                gcel(
                    'div', 
                    {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                    ,
                    gcel(
                        'div', 
                        {className:'bws_hidden_help_text'},
                        'This block is used to display an iframe with the Johns Hopkins dashboard.'
                    )
                )
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Iframe Height: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Input the height of the Iframe that will be embedded in pages. Default is 800px.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'800px', value: height_px, onChange: updateMessage, className: 'coderevolution_gutenberg_input' }
			)
		);
    }),
    save: (function( props ) {
       return null;
    }),
} );