"use strict";
var { registerBlockType } = wp.blocks;
var gcel = wp.element.createElement;

registerBlockType( 'coronavirus-spread-prediction-graphs/cspg-region', {
    title: 'COVID-19 Region Embed',
    icon: 'editor-paste-word',
    category: 'embed',
    attributes: {
        height_px : {
            default: '',
            type:   'string',
        },
        region : {
            default: '',
            type:   'string',
        },
    },
    keywords: ['table', 'coronavirus', 'covid'],
    edit: (function( props ) {
        var height_px = props.attributes.height_px;
        function updateMessage( event ) {
            props.setAttributes( { height_px: event.target.value} );
		}
        var region = props.attributes.region;
        function updateMessage2( event ) {
            props.setAttributes( { region: event.target.value} );
		}
		return gcel(
			'div', 
			{ className: 'coderevolution_gutenberg_div' },
            gcel(
				'h4',
				{ className: 'coderevolution_gutenberg_title' },
                'Regional Dashboard Embed',
                gcel(
                    'div', 
                    {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                    ,
                    gcel(
                        'div', 
                        {className:'bws_hidden_help_text'},
                        'This block is used to display an iframe with regional dashboards.'
                    )
                )
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Irame Height: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Input the height of the Iframe that will be embedded in pages. Default is 800px.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'800px', value: height_px, onChange: updateMessage, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Embed Type: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Select the type of embed to show.'
                )
            ),
            gcel(
                 'select', 
                 {
                    onChange: updateMessage2,
                    value: region, 
                    className: 'coderevolution_gutenberg_select'
                 },
                 gcel("option", {value: "jhu" }, "Johns Hopkins"),
                 gcel("option", {value: "who" }, "WHO"),
                 gcel("option", {value: "healthmap" }, "HealthMap"),
                 gcel("option", {value: "nextstrain" }, "NextStrain"),
                 gcel("option", {value: "virginia" }, "University of Virginia"),
                 gcel("option", {value: "oklahoma" }, "EarlyAlert Oklahoma"),
                 gcel("option", {value: "evolution" }, "ICAO Evolution"),
                 gcel("option", {value: "dispersion" }, "ICAO Dispersion"),
                 gcel("option", {value: "cases" }, "Live Confirmed Cases, Deaths and Recoveries"),
                 gcel("option", {value: "globalconfirmeddeathsrecovered" }, "Live Deaths and Recoveries Graph"),
                 gcel("option", {value: "globaldeathsrecovered" }, "Confirmed Deaths and Recoveries Graph"),
                 gcel("option", {value: "worstaffectedareas" }, "Worst Affected Areas"),
                 gcel("option", {value: "affectedcountries" }, "Affected Countries Map"),
                 gcel("option", {value: "bing" }, "Bing Dashboard"),
                 gcel("option", {value: "livedata" }, "LiveData Dashboard"),
                 gcel("option", {value: "spread" }, "Spread Animated"),
                 gcel("option", {value: "europe" }, "Europe"),
                 gcel("option", {value: "italy" }, "Italy"),
                 gcel("option", {value: "brazil" }, "Brazil"),
                 gcel("option", {value: "brazil2" }, "Brazil Alternative"),
                 gcel("option", {value: "lebanon" }, "Lebanon"),
                 gcel("option", {value: "pakistan" }, "Pakistan"),
                 gcel("option", {value: "uk" }, "United Kingdom"),
                 gcel("option", {value: "romania" }, "Romania"),
                 gcel("option", {value: "romania2" }, "Romania Alternative"),
                 gcel("option", {value: "romaniadaily" }, "Romania Daily"),
                 gcel("option", {value: "romaniacounties" }, "Romania Counties"),
                 gcel("option", {value: "romaniaage" }, "Romania by Age"),
                 gcel("option", {value: "hongkong" }, "Hong Kong"),
                 gcel("option", {value: "macau" }, "Macau"),
                 gcel("option", {value: "china" }, "China"),
                 gcel("option", {value: "shenzhen" }, "Shenzhen China"),
                 gcel("option", {value: "germany" }, "Germany"),
                 gcel("option", {value: "japan" }, "Japan"),
                 gcel("option", {value: "canada" }, "Canada"),
                 gcel("option", {value: "southkorea" }, "South Korea"),
                 gcel("option", {value: "singapore" }, "Singapore"),
                 gcel("option", {value: "taiwan" }, "Taiwan"),
                 gcel("option", {value: "indonesia" }, "Indonesia"),
                 gcel("option", {value: "philippines" }, "Philippines"),
                 gcel("option", {value: "thailand" }, "Thailand"),
                 gcel("option", {value: "israel" }, "Israel"),
                 gcel("option", {value: "israel2" }, "Israel Global"),
                 gcel("option", {value: "portugal" }, "Portugal"),
                 gcel("option", {value: "turkey" }, "Turkey"),
                 gcel("option", {value: "switzerland" }, "Switzerland"),
                 gcel("option", {value: "sweden" }, "Sweden"),
                 gcel("option", {value: "denmark" }, "Denmark"),
                 gcel("option", {value: "india" }, "India"),
                 gcel("option", {value: "usa" }, "USA"),
                 gcel("option", {value: "usa2" }, "USA Alternative"),
                 gcel("option", {value: "usacdcmap" }, "USA CDC Map"),
                 gcel("option", {value: "usacdcchart" }, "USA CDC Chart"),
                 gcel("option", {value: "usacdcillnessonsetchart" }, "USA CDC Illness Onset Chart"),
                 gcel("option", {value: "satellitemap" }, "Global Satellite Map"),
                 gcel("option", {value: "kfftrackermap" }, "KFF Tracker Map"),
                 gcel("option", {value: "florida" }, "Florida"),
                 gcel("option", {value: "usatravel" }, "USA Travel Ban Map"),
                 gcel("option", {value: "london" }, "London"),
                 gcel("option", {value: "confirmedrecoveredmap" }, "Confirmed and Recovered Map"),
                 gcel("option", {value: "globalspread" }, "Global Spread"),
                 gcel("option", {value: "global" }, "Global Map"),
                 gcel("option", {value: "world2" }, "World Map Alternative"),
                 gcel("option", {value: "casesanimated" }, "Cases Animated Bar Chart"),
                 gcel("option", {value: "countrygraphs" }, "Country Graphs"),
                 gcel("option", {value: "countrylist" }, "Country List"),
                 gcel("option", {value: "countrychart2" }, "Country List Alternative"),
                 gcel("option", {value: "globaltablestats" }, "Global Stats Table"),
                 gcel("option", {value: "globalchartstats" }, "Global Charts Table"),
                 gcel("option", {value: "globalcountrystats" }, "Global Country Stats"),
                 gcel("option", {value: "globalevolutionstats" }, "Global Evolution Stats"),
                 gcel("option", {value: "countriesmorethan1000" }, "Countries More Than 1000 Cases"),
                 gcel("option", {value: "selectedcountries" }, "Selected Countries Graph"),
                 gcel("option", {value: "casesovertime" }, "Cases Over Time"),
                 gcel("option", {value: "casesworldwide" }, "Cases Worldwide"),
                 gcel("option", {value: "newcasesperday" }, "New Cases Per Day World"),
                 gcel("option", {value: "newcasesperdaychina" }, "New Cases Per Day China"),
                 gcel("option", {value: "newcasesperdayus" }, "New Cases Per Day USA"),
                 gcel("option", {value: "newcasesperdayeurope" }, "New Cases Per Day Europe"),
                 gcel("option", {value: "newcasesperdayitaly" }, "New Cases Per Day Italy"),
                 gcel("option", {value: "newcasesperdaygermany" }, "New Cases Per Day Germany"),
                 gcel("option", {value: "newcasesperdayspain" }, "New Cases Per Day Spain"),
                 gcel("option", {value: "chinamap" }, "China Spread Map"),
                 gcel("option", {value: "usmap" }, "USA Spread Map"),
                 gcel("option", {value: "eumap" }, "EU Spread Map"),
                 gcel("option", {value: "germanymap" }, "Germany Spread Map"),
                 gcel("option", {value: "doublingstats" }, "Pandemic Doubling Stats")
            )
		);
    }),
    save: (function( props ) {
       return null;
    }),
} );