"use strict";
var { registerBlockType } = wp.blocks;
var gcel = wp.element.createElement;

registerBlockType( 'coronavirus-spread-prediction-graphs/cspg-ui', {
    title: 'COVID-19 User Form Embed',
    icon: 'editor-table',
    category: 'embed',
    attributes: {
        show_table : {
            default: '',
            type:   'string',
        },
        show_new_infected_death_graph : {
            default: '',
            type:   'string',
        },
        show_population_decline_graph : {
            default: '',
            type:   'string',
        },
        show_total_deaths_graph : {
            default: '',
            type:   'string',
        },
        show_total_deaths_infected_graph : {
            default: '',
            type:   'string',
        },
        show_summary : {
            default: '',
            type:   'string',
        },
        show_summary_graph : {
            default: '',
            type:   'string',
        },
        enable_pdf : {
            default: '',
            type:   'string',
        }
    },
    keywords: ['table', 'coronavirus', 'covid'],
    edit: (function( props ) {
        var enable_pdf = props.attributes.enable_pdf;
        function updateMessagepdf( event ) {
            props.setAttributes( { enable_pdf: event.target.value} );
		}
        var show_table = props.attributes.show_table;
        function updateMessage( event ) {
            props.setAttributes( { show_table: event.target.value} );
		}
        var show_new_infected_death_graph = props.attributes.show_new_infected_death_graph;
        function updateMessage2( event ) {
            props.setAttributes( { show_new_infected_death_graph: event.target.value} );
		}
        var show_population_decline_graph = props.attributes.show_population_decline_graph;
        function updateMessage3( event ) {
            props.setAttributes( { show_population_decline_graph: event.target.value} );
		}
        var show_total_deaths_graph = props.attributes.show_total_deaths_graph;
        function updateMessage4( event ) {
            props.setAttributes( { show_total_deaths_graph: event.target.value} );
		}
        var show_total_deaths_infected_graph = props.attributes.show_total_deaths_infected_graph;
        function updateMessage5( event ) {
            props.setAttributes( { show_total_deaths_infected_graph: event.target.value} );
		}
        var show_summary = props.attributes.show_summary;
        function updateMessage6( event ) {
            props.setAttributes( { show_summary: event.target.value} );
		}
        var show_summary_graph = props.attributes.show_summary_graph;
        function updateMessage7( event ) {
            props.setAttributes( { show_summary_graph: event.target.value} );
		}
		return gcel(
			'div', 
			{ className: 'coderevolution_gutenberg_div' },
            gcel(
				'h4',
				{ className: 'coderevolution_gutenberg_title' },
                'User Form Embed',
                gcel(
                    'div', 
                    {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                    ,
                    gcel(
                        'div', 
                        {className:'bws_hidden_help_text'},
                        'This block is used to embed the user form to allow visitors to create their own pandemic scenarios.'
                    )
                )
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show Results Table: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show the results table for user input form? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_table, onChange: updateMessage, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show New Infected + New Deaths Graph: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show the new infected and new death graph for user input form? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_new_infected_death_graph, onChange: updateMessage2, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show Population Decline Graph: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show the population decline graph for user input form? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_population_decline_graph, onChange: updateMessage3, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show Total Deaths Graph: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show the total deaths graph for user input form? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_total_deaths_graph, onChange: updateMessage4, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show Total Infected + Total Deaths Graph: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show the total infected and total deaths comparision graph for user input form? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_total_deaths_infected_graph, onChange: updateMessage5, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show Summary Table: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show a table with the summary of the simulation data? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_summary, onChange: updateMessage6, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Show Summary Chart: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Do you want to show a chart with the summary of the simulation data? Default is true.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'true', value: show_summary_graph, onChange: updateMessage7, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Enable "Generate PDF" Button: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Enable or disable the \'Generate PDF\' button. Default: 0'
                )
            ),
            gcel(
                 'select', 
                 {
                    onChange: updateMessagepdf,
                    value: enable_pdf, 
                    className: 'coderevolution_gutenberg_select'
                 },
                 gcel("option", {value: "0" }, "0"),
                 gcel("option", {value: "1" }, "1")
            )
		);
    }),
    save: (function( props ) {
       return null;
    }),
} );